use encoding "shiftjis";

require './codeconfig.cgi';


%colors = ("46051S1)" => "#DDFFFF",
	   "46051S1N4)" => "#CCEEFF",
	   "46051S1N3N4)" => "#CCCCFF",
	   "46051)" => "#DDEEFF",
	   "46051N4)" => "#BBEEFF",
	   "46050N4)" => "#CCFFEE",
	   "46050)" => "#EEFFDD",
	   "46051S1N4N57)" => "#AAFFFF",
	   "46050N4N57)" => "#EEFFEE",
	   "Firefox/1.5.0.6" => "#FFDDFF",
	   "5.1j Ff/1.5.0.6" => "#FFDDFF",
	   "Firefox/1.5.0.7" => "#FFBBFF",
	   "5.1j Ff/1.5.0.7" => "#FFBBFF",
	   "5.0j Ff/1.5.0.7" => "#FFDDEE",
	   "Netscape/7.0" => "#FFCCEE", 
	   "5.1jJ Ns/7.0" => "#FFCCEE", 
	   "Mozilla/4.08 (P" => "#FFEEBB", 
	   "408 P33 NF/3.3" =>  "#FFEEBB", 
	   "DoCoMo/1.0/D501" => "#FFFFCC",
	   "*" => "RED",
	   "201" => "#CCDDFF",
	   "202" => "#FFDDAA",
	   "203" => "#FFDDAA",
	   "204" => "#FFDDCC",
	   "212" => "#FFBBAA",
	   "213" => "#FFBBAA",
	   "214" => "#FFBBAA",
	   "221" => "#FF8888");

foreach (@AttentionDomain) {
    @tmplist = split(/<>/);
    if ( $tmplist[0] eq "*" ) {
	next;
    }
    if ( $tmplist[1] eq "*" ) {
	$colors{$tmplist[0]} = "#CCCCFF";
    } else {
	$colors{$tmplist[0]} = "#E0F0FF";
	$tmplist[0] .= "*";
	$colors{$tmplist[0]} = "#CCDDFF";
    }
}

foreach (@AttentionDomainS) {
    @tmplist = split(/<>/);
    if ( $tmplist[0] eq "*" ) {
	next;
    }
    if ( $tmplist[1] eq "*" ) {
	$colors{$tmplist[0]} = "#AAAAFF";
    } else {
	$colors{$tmplist[0]} = "#E0F0FF";
	$tmplist[0] .= "**";
	$colors{$tmplist[0]} = "#AABBFF";
    }
}

foreach (@AttentionDomain2) {
    @tmplist = split(/<>/);
    if ( $tmplist[0] eq "*" ) {
	next;
    }
    if ( $tmplist[1] eq "*" ) {
	$colors{$tmplist[0]} = "#FFCCCC";
    } else {
	$colors{$tmplist[0]} = "#FFF0E0";
	$tmplist[0] .= "*";
	$colors{$tmplist[0]} = "#FFDDCC";
    }
}


@AllIssuedList = ();
%IssuedList = ();
%IssuedIndex = ();
@ReverseIndex = ();
%VoteList = ();

$issuenum = 0;
foreach $m (8, 9, 10, 11) {
    for($d=1; $d<32; $d++) {
	$YMD = sprintf("06%02d%02d", $m, $d);
	$MMDD = sprintf("%02d%02d", $m, $d);

	$IssuedListFile = $IssuedListFileHeader . $YMD . ".dat";
	$CodeListTxt = "codelist". $MMDD . ".txt";

	if ( -e $IssuedListFile ) {
	    open(ILF, "$IssuedListFile");
	    while(<ILF>) {
		$issuenum++;
		chop;
		$AllIssuedList[$issuenum] = $_;
		@tmp = split(/<>/);
		if ( $tmp[8] ) {
		    $IssuedList{$tmp[8]} = $issuenum;
		}
		&DecodeIssuedList($AllIssuedList[$issuenum]);
		$tmpdata = "$NewCodeData[3].$NewCodeData[15].$tmp[4].$NewCodeData[5]";
		$IssuedIndex{$tmpdata} = $issuenum;
	    }
	    close(ILF);
	}
    }
}

open CLF, ">:encoding(shift-jis)", "chainlist.html";
print CLF "<HTML>\n";
print CLF "<META http-equiv=\"Content-Type\" content=\"text/html; charset=Shift_JIS\">\n";
print CLF "<BODY>\n";

### voC_ɕ\
print CLF "<A NAME=\"provider\"></A><B>voC_</B>\n";
print CLF "<TABLE BORDER=1>\n";
print CLF "<TR><TH>\</TH><TH></TH><TH>HOST</TH><TH>hC</TH><TH>uEU</TH>\n";
print CLF "<TH>\񎞍</TH><TH>s</TH><TH>NbL[</TH>\n";
print CLF "<TH>`FCP</TH><TH>`FCQ</TH><TH>`FCc</TH><TH>`FCca</TH><TH>sR[h</TH><TH>hCQ</TH>\n";
print CLF "<TH>[</TH><TH>Cookie</TH></TR>\n";

foreach (sort(keys(%IssuedIndex))) {
    $issuenum = $IssuedIndex{$_};
    $check = 0;
    if ( $AllIssuedList[$issuenum] =~ /docomo|ezweb|jp-k.ne|jp-t.ne/ ) {
	next;
    }
    while($issuenum && $AllIssuedList[$issuenum]) {
	&DecodeIssuedList($AllIssuedList[$issuenum]);

	print CLF "<TR>";
	foreach $i (0..5, 14, 8, 9, 10, 16, 18, 13, 15) {
	    $tmp = $NewCodeData[$i];
	    if ( $tmp ) {
		if ( $i == 8 ) {
		    $tmp =~ s/^(.{1}).*/$1/;
		}
		&PrintCell($tmp);
	    } else {
		print CLF "<TD>@</TD>";
	    }
	}
	if(( $NewCodeData[13] ) && ( $VoteList{$NewCodeData[13]} )) {
	    print CLF "<TD NOWRAP>$VoteList{$NewCodeData[13]}</TD>";
	} else {
	    print CLF "<TD>@</TD>";
	}
	&PrintCell(&CaesarCrypt($NewCodeData[8], -$CaesarKey));
    
	print CLF "</TR>\n";

	@tmp = split(/<>/, $AllIssuedList[$issuenum]);
	if ( $tmp[8] ) {
	    $IssuedList{$tmp[8]} = 0;
	}
	$AllIssuedList[$issuenum] = "";
	$issuenum = $IssuedList{$tmp[7]};
	$check = 1;

    }
    if ( $check ) {
	print CLF "<TR><TD>@</TD><TD>@</TD><TD>@</TD><TD>@</TD><TD>@</TD><TD>@</TD><TD>@</TD><TD>@</TD><TD>@</TD><TD>@</TD><TD>@</TD><TD>@</TD><TD>@</TD><TD>@</TD><TD>@</TD><TD>@</TD></TR>\n";
    }
}

print CLF "</TABLE>\n";

print CLF "</BODY></HTML>\n";
close(CLF);

exit(0);


if(-e $CodeListTxt) {
    open(CLT, "$CodeListTxt");
    while(<CLT>) {
	chop;
	@tmp = split(/ /);
	$VoteList{$tmp[1]} = $tmp[2];
    }
}




print CLF "<A HREF=\"#reserve\">\</A>@<A HREF=\"#provider\">voC_</A>@<A HREF=\"#browser\">uEU</A>@<A HREF=\"#error\">G[O</A>@<A HREF=\"#forbidden\">ꎞ~hC</A><BR>\n";

### \񏇂ɕ\
print CLF "<A NAME=\"reserve\"></A><B>\</B>\n";
print CLF "<TABLE BORDER=1>\n";
print CLF "<TR><TH>\</TH><TH></TH><TH>HOST</TH><TH>hC</TH><TH>uEU</TH>\n";
print CLF "<TH>\񎞍</TH><TH>s\</TH><TH>NbL[</TH><TH>NbL[</TH>\n";
print CLF "<TH>`FCP</TH><TH>`FCQ</TH><TH>̎ʔԍ</TH><TH>L</TH><TH>sR[h</TH>\n";
print CLF "<TH>s</TH><TH>hCQ</TH><TH>`FCc</TH><TH>`FCa</TH><TH>`FCca</TH></TR>\n";

open(ILF, "$IssuedListFile");
while(<ILF>) {
    chop;
    $tmpdata = $_;
    &DecodeIssuedList($_);
    $IssuedList{$tmpindex} = $tmpdata;
    $IssuedList2{$tmpindex2} = $tmpdata;
	
    print CLF "<TR>";
    for($i=0; $i<19; $i++) {
	$tmp = $NewCodeData[$i];
	if ( $tmp ) {
	    if ( $i == 7 || $i == 8 || $i == 11 ) {
		$tmp =~ s/^(.{1}).*/$1/;
	    }
	    &PrintCell($tmp);
	} else {
	    print CLF "<TD>@</TD>";
	}
    }
	
    print CLF "</TR>\n";
}
close(ILF);    

print CLF "</TABLE>\n";

print CLF "<BR><HR><BR>\n";


print CLF "<BR><HR><BR>\n";

### uEUɕ\
print CLF "<A NAME=\"browser\"></A><B>uEU</B>\n";
print CLF "<TABLE BORDER=1>\n";
print CLF "<TR><TH>\</TH><TH></TH><TH>HOST</TH><TH>hC</TH><TH>uEU</TH>\n";
print CLF "<TH>\񎞍</TH><TH>s</TH><TH>NbL[</TH>\n";
print CLF "<TH>`FCP</TH><TH>`FCQ</TH><TH>`FCc</TH><TH>`FCa</TH><TH>`FCca</TH><TH>sR[h</TH><TH>hCQ</TH><TH>[</TH></TR>\n";

foreach (sort(keys(%IssuedList2))) {
    &DecodeIssuedList($IssuedList2{$_});
    print CLF "<TR>";
    foreach $i (0..5, 14, 8, 9, 10, 16, 17, 18, 13, 15) {
	$tmp = $NewCodeData[$i];
	if ( $tmp ) {
	    if ( $i == 8 ) {
		$tmp =~ s/^(.{1}).*/$1/;
	    }
	    &PrintCell($tmp);
	} else {
	    print CLF "<TD>@</TD>";
	}
    }
    if(( $NewCodeData[13] ) && ( $VoteList{$NewCodeData[13]} )) {
	print CLF "<TD NOWRAP>$VoteList{$NewCodeData[13]}</TD>";
    } else {
	print CLF "<TD>@</TD>";
    }
    print CLF "</TR>\n";
}

print CLF "</TABLE>\n";

print CLF "<BR><HR><BR>\n";

    

#### V[U[Í
### FA炷
### ԂlFÍ
### gpݒϐF$CaesarStr
sub CaesarCrypt {
    my ($str, $key) = @_;
    my ($pt, $pos, $i, $k, $cp, $text);
    my $nstr = length($str);
    my $ncode = length($CaesarStr);
    $text = "";

    for($i=0; $i<$nstr; $i++) {
	$pt = substr($str, $i, 1);
	if ( ( $pos = index($CaesarStr, $pt) ) >= 0) {
	    $k = ($pos + $key) % $ncode;
	    $cp = substr($CaesarStr, $k, 1);
	    $text .= $cp;
	} else {
	    $text .= $pt;
	}
    }
    return($text);

}


### Z\
sub PrintCell {

    if ( @_[0] =~ /.*\-.Z$/ ) {
	print CLF "<TD NOWRAP BGCOLOR=\"#FFFFDD\">@_[0]</TD>";
    } elsif ( @_[0] =~ /.*\-.Y$/ ) {
	print CLF "<TD NOWRAP BGCOLOR=\"#DDFFDD\">@_[0]</TD>";
    } elsif ( $colors{@_[0]} ) {
	print CLF "<TD NOWRAP BGCOLOR=\"$colors{@_[0]}\">@_[0]</TD>";
    } else {
	print CLF "<TD NOWRAP>@_[0]</TD>";
    }
}


### 
sub DecodeIssuedList {

    my ($tmp) = @_;
    my ($sec, $min, $hour, $bcheck);

    @NewCodeData = split(/<>/, $tmp);
    $tmpindex = sprintf("%s.%s.%d", $NewCodeData[3], $NewCodeData[15], $NewCodeData[5]);
    $tmpindex2 = sprintf("%s.%d", $NewCodeData[4], $NewCodeData[5]);


    ### Domain
    $RemoteDomain = $NewCodeData[2];

    if ( $RemoteDomain =~ /jp$/ ) {
	$RemoteDomain =~ s/.*\.(.+?\..+?\.jp)$/$1/;
	if ( $RemoteDomain !~ /\...\.jp/ ) {
	    $RemoteDomain =~ s/.*\.(.+?\..+?)$/$1/;
	    if ( !$DomainPlace{$RemoteDomain} ) {
		$DomainPlace{$RemoteDomain} = 3;
	    }
	}
    } elsif ( $RemoteDomain =~ /\....$/ ) {
	$RemoteDomain =~ s/.*\.(.+?\..+?)$/$1/;
	if ( !$DomainPlace{$RemoteDomain} ) {
	    $DomainPlace{$RemoteDomain} = 3;
	}
    } else {
	$RemoteDomain =~ s/.*\.(.+?\..+?\...)$/$1/;
    }

    $RemoteDomain2 = $NewCodeData[2];
    if ( $RemoteDomain eq "bbtec.net" ) {
	$RemoteDomain2 =~ s/softbank(\d\d\d)\d*\./$1\./;
    } elsif ( $RemoteDomain eq "hi-ho.ne.jp" ) {
	$RemoteDomain2 =~ s/^(...).*\.(.+?\..+?\..+?\..+?)$/$1\.$2/;
    } elsif ( $RemoteDomain eq "hinet.net" ) {
	$RemoteDomain2 =~ s/^(\d*)\-.*\.(.+?\..+?\..+?)$/$1\.$2/;
    } elsif ( $RemoteDomain eq "infoweb.ne.jp" ) {
	if ( $RemoteDomain2 =~ /\.nt\./ || $RemoteDomain2 =~ /\.te\./ ) {
	    $RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?\..+?\..+?\..+?)$/$1/;
	} else {
	    $RemoteDomain2 =~ s/^(....).*\.(.+?\..+?\..+?\..+?\..+?)$/$1\.$2/;
	}
    } elsif ( $RemoteDomain eq "mesh.ad.jp" ) {
	$RemoteDomain2 =~ s/^(...).*\.(.+?\..+?\..+?\..+?)$/$1\.$2/;
    } elsif ( $RemoteDomain eq "ocn.ne.jp" ) {
	$RemoteDomain2 =~ s/\d//g;
    } elsif ( $RemoteDomain eq "odn.ad.jp" || $RemoteDomain eq "odn.ne.jp" ) {
	$RemoteDomain2 =~ s/^(.....).*\.(.+?\..+?\..+?\..+?)$/$1\.$2/;
    } elsif ( $RemoteDomain eq "prin.ne.jp" ) {
	$RemoteDomain2 =~ s/^(....).*\.(.+?\..+?\..+?\..+?)$/$1\.$2/;
	$RemoteDomain2 =~ s/kd12/p061/;
	$RemoteDomain2 =~ s/p125/p061/;
    } elsif ( $RemoteDomain eq "zaq.ne.jp" ) {
	$RemoteDomain2 =~ s/^zaq(...).*\.(.+?\..+?\..+?)$/$1\.$2/;
    } elsif ( $DomainPlace{$RemoteDomain} == 2 ) {
	$RemoteDomain2 =~ s/.*\.(.+?\..+?)$/$1/;
    } elsif ( $DomainPlace{$RemoteDomain} == 3 ) {
	$RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?)$/$1/;
    } elsif ( $DomainPlace{$RemoteDomain} == 4 ) {
	$RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?)$/$1/;
    } elsif ( $DomainPlace{$RemoteDomain} == 5 ) {
	$RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?\..+?)$/$1/;
    } elsif ( $DomainPlace{$RemoteDomain} == 6 ) {
	$RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?\..+?\..+?)$/$1/;
    } elsif ( $DomainPlace{$RemoteDomain} == 7 ) {
	$RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?\..+?\..+?\..+?\..+?)$/$1/;
    } else {
	$RemoteDomain2 =~ s/.*\.(.+?\..+?\..+?)$/$1/;
    }

    $NewCodeData[3] = $RemoteDomain;
    $NewCodeData[15] = $RemoteDomain2;

    ### Cookie ̂Ȃꍇ
    if ( !$NewCodeData[8] && !$NewCodeData[11] ) {
	$NewCodeData[8] = "*";
    }

    ### AttentionDomain
    $bcheck = "";
    foreach (@AttentionDomainS) {
	@tmplist = split(/<>/);
	if ( $tmplist[0] eq $NewCodeData[15] ) {
	    if ( $tmplist[1] eq $NewCodeData[4] ) {
		$NewCodeData[15] .= "**";
	    }
	} elsif ( $tmplist[0] eq "*" ) {
	    if ( $tmplist[1] eq $NewCodeData[4] ) {
		$bcheck = "**";
	    }
	}
    }
    foreach (@AttentionDomain) {
	@tmplist = split(/<>/);
	if ( $tmplist[0] eq $NewCodeData[15] ) {
	    if ( $tmplist[1] eq $NewCodeData[4] ) {
		$NewCodeData[15] .= "*";
	    }
	} elsif ( $tmplist[0] eq "*" ) {
	    if ( $tmplist[1] eq $NewCodeData[4] ) {
		$bcheck = "**";
	    }
	}
    }
    foreach (@AttentionDomain2) {
	@tmplist = split(/<>/);
	if ( $tmplist[0] eq $NewCodeData[15] ) {
	    if ( $tmplist[1] eq $NewCodeData[4] ) {
		$NewCodeData[15] .= "*";
	    }
	} elsif ( $tmplist[0] eq "*" ) {
	    if ( $tmplist[1] eq $NewCodeData[4] ) {
		$bcheck = "**";
	    }
	}
    }

    ### uEUZk
    $NewCodeData[4] = $bcheck . &AbbBrowser($NewCodeData[4]);

    ### 
    foreach $i (5, 6, 14) {
	if ( $NewCodeData[$i] ) {
	    ($sec, $min, $hour, $day, $mon) = localtime($NewCodeData[$i]);
	    $NewCodeData[$i] = sprintf("%02d/%02d - %02d:%02d:%02d", $mon+1, $day, $hour, $min, $sec);
	}
    }

    ### Chain
    foreach $i (16, 17, 18) {
	$NewCodeData[$i] =~ s/,//g;
    }

    if ( $NewCodeData[15] ) {
	$tmp = $NewCodeData[15];
	$tmp =~ s/\*//g;
	$NewCodeData[2] =~ s/($tmp)/<FONT COLOR=\"BLUE\">$1<\/FONT>/;
    }

}

### uEUZk
sub AbbBrowser {
    my ($str) = @_;
    
    if ( $str =~ /Firefox|Netscape/ ) {
	$str =~ s/Mozilla\/5.0 \(Windows; U; Windows NT //;
	$str =~ s/; en-US;/e/;
	$str =~ s/; ja;/j/;
	$str =~ s/; ja-JP;/jJ/;
	$str =~ s/rv:.*Firefox/Ff/;
	$str =~ s/rv:.*Netscape/Ns/;
    }
    $str =~ s/.*Firefox/Firefox/;
#    $str =~ s/.*Sleipnir/Sleipnir/;
    $str =~ s/Sleipnir\//Sl/;
    $str =~ s/Opera/O/;
#    $str =~ s/.*Netscape/Netscape/;
    $str =~ s/DoCoMo\//D/;
    $str =~ s/KDDI/K/;
    $str =~ s/UP.Browser\/6.2.0.//;
    $str =~ s/Mozilla\/4.0 \(compatible; MSIE 5.5;/455/;
    $str =~ s/Mozilla\/4.0 \(compatible; MSIE 6.0;/460/;
    $str =~ s/Mozilla\/4.0 \(compatible; MSIE 7.0;/470/;
    $str =~ s/Mozilla\/4.0 \(compatible;/4/;
    $str =~ s/Mozilla\/4.08 /408/;
    $str =~ s/ Windows NT 5.1/51/;
    $str =~ s/ Windows NT 5.0/50/;
    $str =~ s/\(Windows NT 5.1/51/;
    $str =~ s/\(Windows NT 5.0/50/;
    $str =~ s/ Windows 98/98/;
    $str =~ s/ Windows CE/CE/;
    $str =~ s/; Win 9x 4.90/9x/;
    $str =~ s/; SV1/S1/;
    $str =~ s/; .NET CLR 1.0.3705/N3/;
    $str =~ s/; .NET CLR 1.1.4322/N4/;
    $str =~ s/; .NET CLR 2.0.50727/N57/;
    $str =~ s/\(PDA; NF33PPC3AR\/1.0\)/ P33/;
    $str =~ s/NetFront/NF/;
    $str =~ s/Mozilla\/5.0 \(Windows; U;/5W/;
    $str =~ s/Mozilla\/5.0 \(Macintosh; /5M/;
    $str =~ s/U; PPC Mac OS X/X/;
    if ( $str =~ /Sl/ ) {
	$str =~ s/46051S1//;
    }
    $str =~ s/^(.{15}).*/$1/;
    
    return($str);
}
